/**
********************************************************************************
Copyright 2012 Ortus Solutions, Corp
www.ortussolutions.com
********************************************************************************
**/
component persistent="true" table="users" entityname="BlogUser" db_sortBy="lastName" displayName="Users"{

	property name="userID" column="user_id" fieldtype="id" generator="uuid";
	property name="firstName" db_labelText="First Name";
	property name="lastName" db_labelText="Last Name";
	property name="username" db_labelText="Username" db_helpText="(Required Size: 5-8)";
	property name="password" db_labelText="Password" db_html="password" db_helpText="(Required Size: 5-8)";
	property name="lastLogin" ormtype="timestamp" db_labelText="Last Login" db_html="datetime";
	property name="isActive" db_labelText="Active" ormtype="boolean" dbdefault="true" default="true";
	
	// One to Many entries
	property name="entry" fieldtype="one-to-many" cfc="Entry" inverse="true";

	// Validation
	this.constraints = {
		firstName = {required = true},
		lastName = {required = true},
		username = {required = true, size="5..8"},
		password = {required = true, size="5..8"},
		lastLogin = {required = false}
	};
}
